<?
	// Include the library of 'account'.
	include_once ( $CONF_INCLUDE_PATH.'/lib-group.inc.php' );

	// Define the langth of group name
	$GROUP_NAME_LENGTH = 20;

	
	// Perpare the request URL
	$requestURL = $PHP_SELF.'?category='.$category.'&mod='.$mod;

	$action = strtolower($action);
	switch ( $action )
	{
		case 'create'	:	// Check the user is click from the first page
							// 'Create a new group' or not
							if ( !isset($create) || $create=='' )
							{
								// Display a Create a new group form
								$myMod = new myModTmp( $MODULES["TEMPLATE_CREATE"], $SESS_CURRENT_LANG );
								$myMod->debug=0;
								$myMod->isAdmin=true;
								$myMod->getTemplate();

								// Dynamic assignment the template variable
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'|'.$myMod->getLangVAR('LANG=CREATE_NEW').'&action=create' );
								$myMod->assign( 'GNAME_MAX_LENGTH', "$GROUP_NAME_LENGTH" );								

								// display the final result in form of HTML
								echo $myMod->getResult();
								
								break;
							}
							elseif ( $gstatus && $gname && $gdescrib )
							{
								// The user click the 'CREATE' button

								// ------------------------------------------------------------------------ //
								// Perpare the error message, only will display when any error occure
								// ------------------------------------------------------------------------ //
								$myMod = new myModTmp( $MODULES["TEMPLATE_ERROR"], $SESS_CURRENT_LANG );
								$myMod->debug=0;
								$myMod->isAdmin=true;
								$myMod->getTemplate();
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'|'.$myMod->getLangVAR('LANG=CREATE_NEW').'&action=create' );
								// ------------------------------------------------------------------------ //

								if ( strtoupper($gstatus) == 'Y' )
									$status = 'Y';
								else
									$status = 'N';

								// Create a object of 'OESgroup'
								$myGroup = new OESgroup();
								$myGroup->debug = 0;

								// Check the new group name is used or not?
								$myGroup->searchMode = '=';
								$findResult = $myGroup->find( '', strtoupper($gname) );


								// --------------------------------------------------------- //
								// Checking have any error before update
								// --------------------------------------------------------- //
								// Not allow any spaces in Group Name
								if ( eregi ( ' ', $gname ) )
								{
									// Found a duplicate group name
									$myMod->assign( 'ERROR_MESSAGE', 'LANG=NO_SPACES_ALLOW' );
									
									// display the error message on screen
									echo $myMod->getResult();
									break;
								}
								// Found a duplicate Group Name then display a error message
								// and ask the user enter the valid group name
								elseif ( count($findResult) )
								{
									// Found a duplicate group name
									$myMod->assign( 'ERROR_MESSAGE', 'LANG=DUPLCATE_GNAME' );
									
									// display the error message on screen
									echo $myMod->getResult();
									break;
								}
								// Check the group name not too long
								elseif ( strlen($gname) > $GROUP_NAME_LENGTH )
								{
									// Found a duplicate group name
									$myMod->assign( 'ERROR_MESSAGE', 'LANG=GNAME_TOO_LONG' );
									
									// display the error message on screen
									echo $myMod->getResult();
									break;
								}
								// Have any error on creating a new group
								elseif ( !$myGroup->newGroup( strtoupper($gname), $gdescrib, $gstatus ) )
								{
									// Found a duplicate group name
									$myMod->assign( 'ERROR_MESSAGE', 'LANG=CANNOT_CREATE' );
									
									// display the error message on screen
									echo $myMod->getResult();
									break;
								}
								// --------------------------------------------------------- //
							}

							// Update successful!! Return to start-up page
							// or the user not enter the group name
							defaultPage();

							break;


		case 'delete'	:	// The user click 'DELETE' that mean trying to delete a record

							// ------------------------------------------------------------------------ //
							// Perpare the error message, only will display when any error occure
							// ------------------------------------------------------------------------ //
							$myMod = new myModTmp( $MODULES["TEMPLATE_ERROR"], $SESS_CURRENT_LANG );
							$myMod->debug=0;
							$myMod->isAdmin=true;
							$myMod->getTemplate();
							$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'&action=edit' );
							// ------------------------------------------------------------------------ //

							// Create a object of 'OESgroup'
							$myGroup = new OESgroup();
							$myGroup->debug = 0;
							
							// You can't delete the group of ROOT (id=1)
							if ( $id <= 1 )
							{
								// The ID is not valid, record not found
								$myMod->assign( 'ERROR_MESSAGE', 'LANG=CANNOT_DELETE_ROOT' );
								
								// display the error message on screen
								echo $myMod->getResult();
								break;
							}
							else
							{
								// Delete the group
								// (i.e. the ID is larger than 1)
								if ( !$myGroup->read($id) )
								{
									// Dynamic assign the error reason
									$myMod->assign( 'ERROR_MESSAGE', 'LANG=RECORD_NOT_FOUND' );

									// display the error message on screen
									echo $myMod->getResult();
									break;
									exit;
								}
								else
									$myGroup->delGroup($id);
							}

							// Display the default page when successful delete a group
							defaultPage();

							break;

		
		case 'update'	:	if ( !$id || isset($cancel) )
								// Display the default page
								defaultPage();
							else
							{
								// ------------------------------------------------------------------------ //
								// Perpare the error message, only will display when any error occure
								// ------------------------------------------------------------------------ //
								$myMod = new myModTmp( $MODULES["TEMPLATE_ERROR"], $SESS_CURRENT_LANG );
								$myMod->debug=0;
								$myMod->isAdmin=true;
								$myMod->getTemplate();
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'|'.$myMod->getLangVAR('LANG=EDIT').'&action=edit&id='.$id );
								// ------------------------------------------------------------------------ //

								// Create a object of 'OESgroup'
								$myGroup = new OESgroup();
								$myGroup->debug = 0;

								// The user click 'SAVE' that mean trying to update the record
								if ( isset($save) && $save!='' )
								{
									// Update the group information

									if ( strtoupper($gstatus) == 'Y' )
										$status = 'Y';
									else
										$status = 'N';

									// Read the current record again
									$result = $myGroup->read( $id );

									if ( !count($result) )
									{
										// The ID is not valid, record not found
										$myMod->assign( 'ERROR_MESSAGE', 'LANG=RECORD_NOT_FOUND' );
										
										// display the error message on screen
										echo $myMod->getResult();
										break;
									}
									else
									{
										// The ID is valid, checking the input data

										// Check the new group name is used or not?
										$myGroup->searchMode = '=';
										$findResult = $myGroup->find( '', strtoupper($gname) );

										// --------------------------------------------------------- //
										// Checking have any error before update
										// --------------------------------------------------------- //
										// Found a duplicate Group Name then display a error message
										// and ask the user enter the valid group name
										if ( count($findResult) && $findResult[0]['id']!=$id )
										{
											// Found a duplicate group name
											$myMod->assign( 'ERROR_MESSAGE', 'LANG=DUPLCATE_GNAME' );
											
											// display the error message on screen
											echo $myMod->getResult();
											break;
										}
										// Check the group name not too long
										elseif ( strlen($gname) > $GROUP_NAME_LENGTH )
										{
											// Found a duplicate group name
											$myMod->assign( 'ERROR_MESSAGE', 'LANG=GNAME_TOO_LONG' );
											
											// display the error message on screen
											echo $myMod->getResult();
											break;
										}
										// Not allow any spaces in Group Name
										elseif ( eregi ( ' ', $gname ) )
										{
											// Found a duplicate group name
											$myMod->assign( 'ERROR_MESSAGE', 'LANG=NO_SPACES_ALLOW' );
											
											// display the error message on screen
											echo $myMod->getResult();
											break;
										}
										// --------------------------------------------------------- //


										// Not allow change the group name of ROOT
										// (i.e. the ID is less than or equal to 1)
										if ( $id<=1 )
											$gname = $result[0]['group_name'];


										// Update the group information
										if ( ! $myGroup->update( $id, strtoupper($gname), $gdescrib, $status ) )
										{
											// Can't update the record
											$myMod->assign( 'ERROR_MESSAGE', 'LANG=CANNOT_UPDATE' );
											
											// display the error message on screen
											echo $myMod->getResult();
											break;
										}									
									}

								}

								// Display the default page after update or delete
								defaultPage();
							}

							break;


		case 'edit'		:	if ( !$id )
								defaultPage();
							else
							{
								$myGroup = new OESgroup();
								$myGroup->debug = 0;
								$result = $myGroup->read( $id );


								$myMod = new myModTmp( $MODULES["TEMPLATE_EDIT"], $SESS_CURRENT_LANG );
								$myMod->debug=0;
								$myMod->isAdmin=true;
								$myMod->getTemplate();

								// Dynamic assignment the template variable
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'&action=update&id='.$id );
								$myMod->assign( 'GNAME_MAX_LENGTH', "$GROUP_NAME_LENGTH" );								
								$myMod->assign( 'DELETE_URL'	  , $requestURL.'|'.$myMod->getLangVAR('LANG=EDIT').'&action=delete&id='.$id );

								$myMod->assign( 'GID', $result[0]['id'] );
								if ( $result[0]['group_enable'] == 'Y' )
									$myMod->assign( 'gstart_chekcked', 'checked' );
								else
								$myMod->assign( 'gstop_chekcked', 'checked' );
								$myMod->assign( 'GNAME'		, $result[0]['group_name'] );
								$myMod->assign( 'GDESCRIB'	, $result[0]['group_describe'] );

								// display the final result in form of HTML
								echo $myMod->getResult();
							}

							break;


		default			:	defaultPage();
							break;
	}


	////////////////////////////////////////////////
	// Function : defaultPage()                   //
	//                                            //
	// A function to display the default page in  //
	// browser.                                   //
	////////////////////////////////////////////////
	function defaultPage()
	{
		// This function is used to list all the group in the system

		GLOBAL
			$sortby,
			$SESS_CURRENT_LANG,
			$MODULES,
			$requestURL,
			$PHP_SELF,
			$category,
			$mod;

		$myGroup = new OESgroup();
		$myGroup->debug = 0;

		// Checking the sorting mode is accending or descending
		$sortby = explode ( '|', $sortby );
		if ( strtoupper($sortby[1]) == 'DESC' )
		{
			$myGroup->orderMode = 'DESC';
			$sortmode = 'ASC';
		}
		else
		{
			$myGroup->orderMode = 'ASC';
			$sortmode = 'DESC';
		}
		$sortby = $sortby[0];

		switch ( strtolower($sortby) )
		{
			case 'status'	:	$sortbyField = 'group_enable'; break;
			case 'name'		:	$sortbyField = 'group_name'; break;
			case 'describe'	:	$sortbyField = 'group_describe'; break;
			case 'id'		:
			default			:	$sortbyField = 'id'; break;
		}

		// Get all group record
		$result = $myGroup->find( '','','', $sortbyField );

		if ( !$result )
		{
			// No Record found!!

			$myMod = new myModTmp( $MODULES["TEMPLATE_NO_RECORD"], $SESS_CURRENT_LANG );
			$myMod->debug=0;
			$myMod->isAdmin=true;
			$myMod->getTemplate();

			// Dynamic assignment the template variable
			$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'&action=' );

			// display the final result in form of HTML
			echo $myMod->getResult();								
		}
		else
		{
			// Record Founded!!

			// Create a modules template object
			$myMod = new myModTmp( $MODULES["TEMPLATE"], $SESS_CURRENT_LANG );
			$myMod->debug=0;
			$myMod->isAdmin=true;
			$myMod->getTemplate();

			$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'|'.$myMod->getLangVAR('LANG=CREATE_NEW').'&action=create' );
			
			$myMod->assign( 'SORT-BY_GID_URL'		, $requestURL.'&sortby=id|'.$sortmode );
			$myMod->assign( 'SORT-BY_GSTATUS_URL'	, $requestURL.'&sortby=status|'.$sortmode );
			$myMod->assign( 'SORT-BY_GNAME_URL'		, $requestURL.'&sortby=name|'.$sortmode );
			$myMod->assign( 'SORT-BY_GDESCRIBE_URL'	, $requestURL.'&sortby=describe|'.$sortmode );

			for ( $i=0; $i<count($result); $i++)
			{
				// Dynamic assignment the template variable
				$myMod->assign( 'GID'		, $result[$i]['id'] );
				if ( strtoupper($result[$i]['group_enable']) == 'Y' )
					$myMod->assign( 'GSTATUS'	, 'LANG=START' );
				else
					$myMod->assign( 'GSTATUS'	, 'LANG=STOP' );
				$myMod->assign( 'GNAME'		, strtoupper($result[$i]['group_name']) );
				$myMod->assign( 'GDESCRIBE'	, $result[$i]['group_describe'] );
				$myMod->assign( 'EDIT_URL'	, $PHP_SELF.'?category='.$category.'&mod='.$mod.'|'.$myMod->getLangVAR('LANG=EDIT').'&action=edit&id='.$result[$i]['id'] );

				if ( ($i+1) < count($result) )
					// Repeat the ROWs
					$myMod->repeatRow( 'groupList' );
			}

			// display the final result in form of HTML
			echo $myMod->getResult();
		}
		// -= End of Function : defaultPage() =-

	}
?>