<?php
	// File        : /include/lib-time.inc.php
	//
	// Description : This library contain the class for time function.

	///////////////////////////////////////////	
	// CLASS - c_Timer();			         //
	// Calc. time between two actions        //
	//										 //
	///////////////////////////////////////////
	// Usage							     //
	//	$timer = new c_Timer;				 //
	//	$timer->start();					 //
	//	$timer->stop();						 //
	//	echo $timer->elapsed();				 //
	///////////////////////////////////////////
	class myTimer { 
	    var $t_start = 0; 
	    var $t_stop = 0; 
	    var $t_elapsed = 0; 
	     
	    function start() { $this->t_start = microtime(); } 
	    function stop()  { $this->t_stop  = microtime(); } 

	    function elapsed() 
		{ 
			if ($this->t_elapsed) 
			{ 
				return $this->t_elapsed; 
			} 
			else 
			{ 
				$start_mt = explode (" ", $this->t_start); 
				$stop_mt = explode (" ", $this->t_stop); 
				$start_total = doubleval($start_mt[0]) + $start_mt[1]; 
				$stop_total  = doubleval($stop_mt[0]) + $stop_mt[1]; 
				$this->t_elapsed = $stop_total - $start_total; 
			    return $this->t_elapsed; 
			} 
	    } 
	}; 
?>