<?
	// File        : /include/setup/config.inc
	//
	// Description : Template of configuration file.
	
	/*
	 * Open Education System
	 *
	 * Latest version is available at http://openedusys.sourceforge.net
	 * This is the configuration file for OES (Open Education System).
	 */

	// *** You should modifier this line for the first run.            ***
	// *** This variables contains the path of the OES is installed.   ***
	
	// The system path of Open Education System? (FULL PATH)
	// *** REMEMBER!! If OES is running on windows system, please make ***
	// *** sure the system path is correct.                            ***
	$CONF_SYSTEM_PATH           = '{INSTALLED_PATH}';
	
	// The URL will OES be work on?
	$CONF_SYSTEM_URL            = '{INSTALLED_URL}';

	// The administration URL
	$CONF_ADMIN_URL             = '{ADM_URL}';
	


	// ********************************  Warning!! **************************************
	// *** NERVER change this to TRUE unless root administrator is forget the password **
	// *** ( the default ID and Password would be 'rootAdmin' , 'rootPassword' )       **
	// **********************************************************************************
	$CONF_FORGET_ROOT_PWD       = FALSE;


	//////////////////////////////////////////////////////////////
	//                       Warning!!                          //
	//                                                          //
	// Don't modifier the following part, unless you understand //
	// what you are doing.                                      //
	//////////////////////////////////////////////////////////////
	$CONF_SERVER_NAME           =  'Open Educational System'; 
	$CONF_SERVER_VER            =  'v0.1(beta)'; 

	// URL for OES Home
	$CONF_OES_URL               = 'http://openeducation.sourceforge.net';
	$CONF_SESSION_TIMEOUT       = 600;                    // Default timeout is 600 second


	// Database setting
	$CONF_DATABASE_TYPE         = '{DB_TYPE}';
	$CONF_DATABASE_ADDR         = '{DB_ADDR}';
	$CONF_DATABASE_PORT         = '{DB_PORT}';
	$CONF_DATABASE_DBNAME       = '{DB_NAME}';
	$CONF_DATABASE_ID           = '{DB_USER}';
	$CONF_DATABASE_PWD          = '{DB_PWD}';


	// Start Administrator Page Setting
	$CONF_ADMIN_PATH            = $CONF_SYSTEM_PATH.'{ADM_PATH}';
	$CONF_ADMIN_THEMES_PATH     = $CONF_SYSTEM_PATH.'{ADM_THEMES_PATH}';
	$CONF_ADMIN_MODULES_PATH    = $CONF_SYSTEM_PATH.'{ADM_MODULES_PATH}';
	$CONF_ADMIN_SESSION_PATH    = $CONF_SYSTEM_PATH.'{ADM_SESSION_PATH}';
	$CONF_ADMIN_SESSION_TIMEOUT = 0;                      // Default timeout is NERVER


	// The path of OES library
	$CONF_CONFIG_PATH           = $CONF_SYSTEM_PATH.'{CONFIG_PATH}';
	$CONF_INCLUDE_PATH          = $CONF_SYSTEM_PATH.'{INCLUDE_PATH}';
	$CONF_THEMES_PATH           = $CONF_SYSTEM_PATH.'{THEMES_PATH}';
	$CONF_MODULES_PATH          = $CONF_SYSTEM_PATH.'{MODULES_PATH}';
	$CONF_SESSION_PATH          = $CONF_SYSTEM_PATH.'{SESSION_PATH}';


	// Default Themes
	$CONF_DEFAULT_ADMIN_THEMES  = 'OES.default';
	$CONF_DEFAULT_USER_THEMES   = 'OES.default';


	// Define the default download speed
	$CONF_DOWNLOAD_SPEED        = 0;
?>
