<?
	// Include the library of 'account'.
	include_once ( $CONF_INCLUDE_PATH.'/lib-account.inc.php' );

	// Include the library of 'account'.
	include_once ( $CONF_INCLUDE_PATH.'/lib-group.inc.php' );

	// The following variable store how many rows of record
	// display on each page. If $listRecNum=0 which mean
	// no display limit and display all record.
	$listRecNum = 10;

	// Change to lower case
	$action = strtolower($action);


	switch ($action)
	{
		case 'new'		:	if ( isset($frmUpdate) )
							{
								// Perpare the error template
								$myMod = new myModTmp( $MODULES["TEMPLATE_CREATE_ERROR"], $SESS_CURRENT_LANG );
								$myMod->debug=0;
								$myMod->isAdmin=true;
								$myMod->getTemplate();
								$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=create';
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL );

								$errorNum = 1;

								// Check the status of the new account
								if ( $loginStatus == 'Y' )
									$record['ac_enable'] = 'Y';
								else
									$record['ac_enable'] = 'N';


								// Do not provide the login id
								if ( !$admLoginID )
									$error .= ($errorNum++).'. '.$myMod->getLangVAR('LANG=ERROR_NO_LOGINID')."<br>\n";
								elseif ( $admLoginID!='' )
								{
									// Check the login name to make sure not used by other
									$adm = new Admin_Account();
									$adm->debug=0;
									$adm->searchMode = '=';
									$result = $adm->find( '', $admLoginID );
									if ( count($result) )
										// The password is not the same, display error message
										$error .= ($errorNum++).'. '.$myMod->getLangVAR('LANG=ERROR_AC_USED')."<br>\n";
								}



								// If the password is typing the same, save it
								if ( ( $admPwd == $admPwd2 ) && $admPwd!='' && $admPwd2!='' )
									// Call the function to encrypt the password
									$record['adm_login_passwd'] = encryptString($admPwd, 250);
								elseif ( $admPwd!='' && $admPwd2!='' )
									// The password is not the same, display error message
									$error .= ($errorNum++).'. '.$myMod->getLangVAR('LANG=ERROR_PWD_NOT_MATCH')."<br>\n";
								else
									$error .= ($errorNum++).'. '.$myMod->getLangVAR('LANG=ERROR_NO_PASSWD')."<br>\n";


								// Check the group
								if ( strlen($oesGroup)<1 )
									$error .= ($errorNum++).'. '.$myMod->getLangVAR('LANG=ERROR_NO_GROUP')."<br>\n";


								// Check the IP access control
								if ( strtolower($IP_ACCESS) == 'allow' )
								{
									$record['ip_access_list'] = $IPaddress;
									$record['ip_deny_list'] = '';
								}
								elseif ( strtolower($IP_ACCESS) == 'deny' )
								{
									$record['ip_deny_list'] = $IPaddress;
									$record['ip_access_list'] = '';
								}
								else
								{
									$record['ip_access_list'] = '';
									$record['ip_deny_list'] = '';
								}


								// Perpare the modules allow information
								if ( !is_array($modAllow) )
									$record['modules_allow'] = '';
								else
								{
									foreach ( $modAllow as $modules )
									{
										$modules = explode( '|', $modules );
										$catAllow[$modules[0]] .= $modules[1].',';
									}
									unset($modAllow);
									foreach ( array_keys($catAllow) as $cat )
									{
										$catAllow[$cat] = substr( $catAllow[$cat], 0, (strlen($catAllow[$cat])-1) );
										$modAllow .= $cat.':'.$catAllow[$cat].'|';
									}
									$record['modules_allow']	= $modAllow;
								}


								$record['parent']			= $SESS_ID;		// Save the current administrator ID,
								$record['adm_login_id']		= $admLoginID;	// to inducate this account is created by who
								$record['adm_name']			= $admName;
								$record['adm_describe']		= $admDescribe;
								$record['adm_email']		= $admEmail;
								$record['adm_group']		= $oesGroup;
								$record['default_lang']		= $admLang;
								$record['default_themes']	= $admTheme;
								$record['create_date']		= date('Y-m-d H:i:s');
								$record['expire_date_time']	= $expireDate;


								if ( isset($error) || $error!='' )
								{
									// Have error occure, display the error page
									$myMod->assign( 'ERROR_MESSAGE', $error );

									// display the error page
									echo $myMod->getResult();
								}
								else
								{
									// Create a new account
									if ( $newID = $adm->newAdmin($record) )
									{
										$myMod = new myModTmp( $MODULES["TEMPLATE_CREATE_SUCCESS"], $SESS_CURRENT_LANG );
										$myMod->debug=0;
										$myMod->isAdmin=true;
										$myMod->getTemplate();

										// Perpare the request URL
										$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList);
										$myMod->assign( 'FORM_ACTION_PATH', $requestURL );

										echo $myMod->getResult();
										break;
									}
									else
									{
										// Create new account have any error, display the error message
										$myMod->assign( 'ERROR_MESSAGE', $adm->error() );

										// display the error page
										echo $myMod->getResult();
										break;
									}
								}
							}
							break;


		case 'create'	:	$myMod = new myModTmp( $MODULES["TEMPLATE_CREATE"], $SESS_CURRENT_LANG );
							$myMod->debug=0;
							$myMod->isAdmin=true;
							$myMod->getTemplate();

							// Perpare the request URL
							$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=new';
							$myMod->assign( 'FORM_ACTION_PATH', $requestURL );

							// Change the input box size
							// (normally use for old version netscape)
							if ( cssSupport() )
								$myMod->assign( 'box_size', '40' );
							else
								$myMod->assign( 'box_size', '25' );


							// ---------------------------------------------------------------------- //
							// Check the group and perpare to display
							// ---------------------------------------------------------------------- //
							$myGroup = new OESgroup();
							$myGroup->debug = 0;
							$myGroup->orderBy = 'group_name,id,group_enable';
							$myGroup->orderMode = 'ASC';
							$myGroup->selectLimit = 0;


							// Get all group record
							$group = $myGroup->find();

							for ( $i=0; $i<count($group); $i++ )
							{
								// Assign the group name in the selection box
								if ( strtoupper($group[$i]['group_enable']) == 'Y' )
									$thisName = strtoupper($group[$i]['group_name']).' ('.$group[$i]['id'].')';
								else
									$thisName = strtoupper($group[$i]['group_name']).' ('.$myMod->getLangVAR('LANG=DISABLE').')';

								// The administrator is in the group
								$myMod->assign( 'ADM_GROUP', '<option value='.$group[$i]['id'].">$thisName</option>" );

								if ( ($i+1) < count($group) )
									$myMod->repeatRow( 'ADM_GROUP-R' );
							}
							// ---------------------------------------------------------------------- //


							// ---------------------------------------------------------------------- //
							// Display the Theme can be select
							// ---------------------------------------------------------------------- //
							// Try to open the admin theme directory
							if ( @$d = dir( $CONF_ADMIN_THEMES_PATH ) )
							{
								// read the sub directory of this theme
								$i=0;
								while (false !== ($entry = $d->read())) {
									if ( $entry != "." && $entry != ".." && is_dir($CONF_ADMIN_THEMES_PATH.'/'.$entry) ) 
										$themeList[$i++] = $entry;
								}
								$d->close();

								if ( count($themeList) )
								{
									// Sort the modules name
									sort( $themeList );

									$enableTheme = array();
									for ( $i=0, $j=0; $i<count($themeList); $i++ )
									{
										$themeConfigPath =  $CONF_ADMIN_THEMES_PATH.'/'.$themeList[$i].'/themes.php';
										if ( @include($themeConfigPath) )
										{
											// Check the themes is enable or disabled?
											if ( $THEMES_ENABLE )
											{
												$THEMES_NAME .= ':'.$themeList[$i];
												$enableTheme[$THEMES_NAME] = array();

												// Read the language set
												if ( $langDir = dir($CONF_ADMIN_THEMES_PATH.'/'.$themeList[$i].$THEMES_LANG_DIR) )
												{
													// Checking which language file in the theme
													$j=0;
													while (false !== ($langEntry = $langDir->read())) {
														// Only allow the file end with '*.lang.php' to be a language file
														if ( $langEntry != "." && $langEntry != ".." && eregi('^(.*)(.lang.php)$', $langEntry) ) 
															$enableTheme[$THEMES_NAME][$j++] = $langEntry;
													}
													$langDir->close();

													// Check the language file on each themes
													for ($k=0; $k<count($enableTheme[$THEMES_NAME]); $k++)
													{
														if ( @include ($CONF_ADMIN_THEMES_PATH.'/'.$themeList[$i].$THEMES_LANG_DIR.'/'.$enableTheme[$THEMES_NAME][$k]) )
														{
															// Perpare the JavaScript for dynamic change the selection
															$lang = eregi_replace( '.lang.php', '', $enableTheme[$THEMES_NAME][$k] );
															$enableTheme[$THEMES_NAME][$k] = 'new Array("'.$LANG_NAME.'", "'.$lang.'")';

															// If the current theme is the same as the system default
															// The display the current themes language set.
															if ( $themeList[$i] == $CONF_DEFAULT_ADMIN_THEMES )
															{
																$myMod->assign( 'DEFAULT_LANG_NAME', $LANG_NAME );
																$myMod->assign( 'LANG_VALUE', $lang );

																// If the current language is same as the system default
																if ( $lang == $CONF_DEFAULT_USER_THEMES )
																	$myMod->assign( 'langSelected', 'selected' );
																else
																	$myMod->assign( 'langSelected', '' );

																// If not finish to display the language, repeat a row
																if ( ($k+1) < count($enableTheme[$THEMES_NAME]) )
																	$myMod->repeatRow( 'ADM_LANG' );
															}
														}
													}
												}
											}
										}
									}

									// Generate the Javascript for dynamic change the selection
									$i=0;
									$langArray = '';
									foreach ( array_keys($enableTheme) as $themeName )
									{
										// Dynamic assign the themes to template 
										$name = explode ( ':', $themeName );
										$myMod->assign( 'DEFAULT_THEME', $name[0] );
										$myMod->assign( 'THEME_VALUE', $name[1] );												

										// The themes is current using, select it
										if ( $name[1] == $CONF_DEFAULT_ADMIN_THEMES )
											$myMod->assign( 'themeSelected', 'selected' );
										else
											$myMod->assign( 'themeSelected', '' );

										// Perpare JavaScript...
										if ( count($enableTheme[$themeName]) )
										{
											$langArray .= "Array ( ";
											$langArray .= 'new Array("-= '.$myMod->getLangVAR('LANG=DEFAULT').' ('.$name[0].') =-", ""),';
											for ( $count=0; $count<count($enableTheme[$themeName]); $count++)
											{
												$langArray .= $enableTheme[$themeName][$count];
												if ( ($count+1) < count($enableTheme[$themeName]) )
													$langArray .= ',';
											}
											$langArray .= " )";
										}
										else
											// This theme don't have any language file in, display the use as default.
											$langArray .= 'Array ( new Array("-= '.$myMod->getLangVAR('LANG=DEFAULT').' ('.$name[0].') =-", "") )';

										// If not finish display all the theme, repeat a ROW of template
										if ( ($i+++1) < count($enableTheme) )
										{
											$myMod->repeatRow( 'ADM_THEME' );
											$langArray .= ','."\n";
										}
									}
								}
							}

							// Assign the Javascript to the template
							$myMod->assign( 'LANG_ARRAY', $langArray );
							$myMod->assign( 'DEFAULT_LANG_NAME', '-= '.$myMod->getLangVAR('LANG=DEFAULT').' =-' );
							$myMod->assign( 'LANG_VALUE', '' );
							$myMod->assign( 'langSelected', '' );									
							// ---------------------------------------------------------------------- //


							// ---------------------------------------------------------------------- //
							// Display the modules check box
							// ---------------------------------------------------------------------- //
							$modAllowList = '';
							if ( @$d = dir( $CONF_ADMIN_MODULES_PATH ) )
							{
								// read all modules for the administrator
								$i=0;
								while (false !== ($entry = $d->read())) {
									if ( $entry != "." && $entry != ".." && is_dir($CONF_ADMIN_MODULES_PATH.'/'.$entry) ) 
										$categoryList[$entry] = array();
								}
								$d->close();

								foreach ( array_keys($categoryList) as $category )
								{
									if ( @$modDir = dir( $CONF_ADMIN_MODULES_PATH.'/'.$category ) )
									{
										$i=0;
										while (false !== ($entry = $modDir->read())) {
											if ( $entry != "." && $entry != ".." && is_dir($CONF_ADMIN_MODULES_PATH.'/'.$category.'/'.$entry) ) 
												$categoryList[$category][$i++] = $entry;
										}
										$modDir->close();

										for ( $i=0; $i<count($categoryList[$category]); $i++ )
											if ( @include($CONF_ADMIN_MODULES_PATH.'/'.$category.'/'.$categoryList[$category][$i].'/module.php') )
												$categoryList[$category][$i] .= ':'.$MODULES["NAME"];
									}
									
								}
							}
							
							// Rearrange the order of categoty
							$sModules['0:oes']			= $categoryList['oes'];
							$sModules['1:user_account']	= $categoryList['user_account'];
							$sModules['2:system']		= $categoryList['system'];
							$sModules['3:modules']		= $categoryList['modules'];
							$sModules['4:support']		= $categoryList['support'];
							$categoryList = $sModules;

							// Split the modules setting in this account
							$modList = explode( '|', $result[0]['modules_allow'] );
							foreach ( $modList as $mod )
							{
								$mod = explode( ':', $mod );
								$modAllowed[$mod[0]] = explode( ',', $mod[1] );
							}

							$i=0;
							foreach ( array_keys($categoryList) as $category )
							{
								$categoryName = explode( ':', $category );
								$myMod->assign( 'CATEGORY', '-= '.strtoupper($categoryName[1]).' =-' );

								if ( !count($categoryList[$i.':'.$categoryName[1]]) )
								{
									$myMod->assign( 'CHECKBOX', '' );
									$myMod->assign( 'CHECKBOX_NAME', $myMod->getLangVAR('LANG=NONE_OF_MODULES') );
								}
								else
									for ( $j=0; $j<count($categoryList[$i.':'.$categoryName[1]]); $j++ )
									{
										$mod = explode( ':', $categoryList[$i.':'.$categoryName[1]][$j] );
										$CHECKBOX = '<input type="checkbox" name="modAllow[]" value="'.$categoryName[1].'|'.$mod[0].'">';
										$myMod->assign( 'CHECKBOX', $CHECKBOX );
										$myMod->assign( 'CHECKBOX_NAME', $mod[1] );

										if ( ($j+1) < count($categoryList[$i.':'.$categoryName[1]]) )
											$myMod->repeatRow( 'modules' );
									}
								
								if ( ($i+++1) < count($categoryList) )
								{
									// Delete the Repeat Row in the result part
									$myMod->removeRow( 'modules' );
									$myMod->repeatRow( 'category' );
								}
							}
							// ---------------------------------------------------------------------- //

							// display the create account template
							echo $myMod->getResult();
							break;


		case 'delete'	:	if ( is_numeric($id) && $id>=1 )
							{
								// You do not allow to delete the ROOT administrator
								if ( $id<=1 )
								{
									$myMod = new myModTmp( $MODULES["TEMPLATE_ERROR"], $SESS_CURRENT_LANG );
									$myMod->debug=0;
									$myMod->isAdmin=true;
									$myMod->getTemplate();

									$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=browse';
									$myMod->assign( 'FORM_ACTION_PATH', $requestURL );
									$myMod->assign( 'ERROR_MESSAGE', $myMod->getLangVAR('LANG=ERROR_DELETE_ROOT') );
								}
								else
								{
									$adm = new Admin_Account();
									$adm->debug=0;
									if ( !$adm->delAccount( $id ) )
									{
										$myMod = new myModTmp( $MODULES["TEMPLATE_ERROR"], $SESS_CURRENT_LANG );
										$myMod->debug=0;
										$myMod->isAdmin=true;
										$myMod->getTemplate();

										$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=browse';
										$myMod->assign( 'FORM_ACTION_PATH', $requestURL );
										$myMod->assign( 'ERROR_MESSAGE', $myMod->getLangVAR('LANG=ERROR_DELETE_FAIL') );
									}
									else
									{
										$myMod = new myModTmp( $MODULES["TEMPLATE_DELETE_SUCCESS"], $SESS_CURRENT_LANG );
										$myMod->debug=0;
										$myMod->isAdmin=true;
										$myMod->getTemplate();

										$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=browse';
										$myMod->assign( 'FORM_ACTION_PATH', $requestURL );
									}
								}

								// display the error page
								echo $myMod->getResult();
								break;
							}


		case 'update'	:	if ( is_numeric($id) && $id>=1 && isset($frmUpdate) )
							{
								$myMod = new myModTmp( $MODULES["TEMPLATE_ERROR"], $SESS_CURRENT_LANG );
								$myMod->debug=0;
								$myMod->isAdmin=true;
								$myMod->getTemplate();

								$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=edit&id='.$id;
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL );

								// Cleat the error
								$error = '';

								// If enter the new password, check the typing is match?
								if ( $admPwd || $admPwd2 )
									if ( $admPwd == $admPwd2 )
										// Call the function to encrypt the password
										$record['adm_login_passwd'] = encryptString($admPwd, 250);
									else
										$error .= $myMod->getLangVAR('LANG=ERROR_PWD_NOT_MATCH')."<br>\n";

								// check the expire date and time
								if ( !$expireDate || $expireDate=='' )
									$expireDate = '9999-12-31 23:59:59';


								// Check the access list
								$IP_ACCESS = strtolower($IP_ACCESS);
								if ( $IP_ACCESS=='allow' || $IP_ACCESS=='deny' )
								{
									// Seperate the IP access list by enter or ','
									if ( eregi( ',', $IPaddress ) )
										$IPlist = split( ',', $IPaddress );
									elseif ( eregi( "\n", $IPaddress ) )
										$IPlist = split( "\n", $IPaddress );
									else
									{
										$IPlist = array();
										$IPlist[0] = $IPaddress;
									}

									if ( !is_array($IPlist) && !is_string($IPlist) )
										$error .= $myMod->getLangVAR('LANG=ERROR_IPAddress')."<br>\n";
									else
									{
										for ( $i=0; $i<count($IPlist); $i++ )
										{
											ereg( "([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)", $IPlist[$i], $ip );
											$IPlist[$i] = $ip[0];

											$ip_long = ip2long($IPlist[$i]);
											$ip_reverse = long2ip($ip_long);
											if ( $IPlist[$i] != $ip_reverse )
											{
												$error .= $myMod->getLangVAR('LANG=ERROR_IPAddress')."<br>\n";
												break;
											}
										}

										if ( is_array($IPlist) )
											$IPaddress = implode( ',', $IPlist );
									}
								}								
								else
									// The access is allow from any where
									$IPaddress = '';


								// If have any error occur, display the error page and stop to update.
								if ( $error!='' )
								{
									$myMod->assign( 'ERROR_MESSAGE', $error );

									// display the error page
									echo $myMod->getResult();
									break;
								}
								else
								{
									// Do not have any error, update the account information

									$record['expire_date_time'] = $expireDate;
									$record['adm_name'] = $admName;
									$record['adm_describe'] = $admDescribe;
									$record['adm_email'] = $admEmail;
									$record['adm_group'] = $oesGroup;
									$record['default_lang'] = $admLang;
									$record['default_themes'] = $admTheme;


									// Check the account is it allow to login
									if ( strtolower($loginStatus)=='y' || $id<=1 )
										$record['ac_enable'] = 'Y';
									else
										$record['ac_enable'] = 'N';


									// Check the access is allow of deny from a IP address
									if ( strtolower($IP_ACCESS)=='allow' )
									{
										$record['ip_access_list'] = $IPaddress;
										$record['ip_deny_list'] = '';
									}
									elseif ( strtolower($IP_ACCESS)=='deny' )
									{
										$record['ip_access_list'] = '';
										$record['ip_deny_list'] = $IPaddress;
									}
									else
									{
										$record['ip_access_list'] = '';
										$record['ip_deny_list'] = '';
									}


									// Perpare the modules allow information
									if ( !is_array($modAllow) )
										$record['modules_allow'] = '';
									else
									{
										foreach ( $modAllow as $mod )
										{
											$mod = explode( '|', $mod );
											$catAllow[$mod[0]] .= $mod[1].',';
										}
										unset($modAllow);
										foreach ( array_keys($catAllow) as $cat )
										{
											$catAllow[$cat] = substr( $catAllow[$cat], 0, (strlen($catAllow[$cat])-1) );
											$modAllow .= $cat.':'.$catAllow[$cat].'|';
										}
										$record['modules_allow'] = $modAllow;
									}


									// Trying to update the account information
									$adm = new Admin_Account();
									$adm->debug=0;
									if ( !$adm->update( $id, $record ) )
									{
										// Account update fail
										$myMod->assign( 'ERROR_MESSAGE', $myMod->getLangVAR('LANG=ERROR_UPDATE_FAIL') );

										// display the error page
										echo $myMod->getResult();
										break;
									}
									
									// Reset the modules
									// (i.e. the URL variable $mod)
									$mod=$modList[0];
								}
							}


		case 'edit'		:	if ( is_numeric($id) && $id>=1 )
							{
								$adm = new Admin_Account();
								$adm->debug=0;
								$result = $adm->read($id);

								if ( !$result )
								{
									// None of record
								}
								else
								{
									// Record Found!!

									// ---------------------------------------------------------------------- //
									// Display Record
									// ---------------------------------------------------------------------- //
									$myMod = new myModTmp( $MODULES["TEMPLATE_UPDATE"], $SESS_CURRENT_LANG );
									$myMod->debug=0;
									$myMod->isAdmin=true;
									$myMod->getTemplate();

									// Perpare the request URL
									$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=update&id='.$id;
									$myMod->assign( 'FORM_ACTION_PATH', $requestURL );

									$myMod->assign( 'ID', $result[0]['id'] );
									$myMod->assign( 'AC_NAME', $result[0]['adm_login_id'] );
									$myMod->assign( 'DELETE_URL', $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=delete&id='.$id );

									// Change the input box size
									// (normally use for old version netscape)
									if ( cssSupport() )
										$myMod->assign( 'box_size', '40' );
									else
										$myMod->assign( 'box_size', '25' );

									$myMod->assign( 'ID'	, $result[0]['id'] );
									$myMod->assign( 'CREATE_DATE'	, $result[0]['create_date'] );
									$myMod->assign( 'EXPIRE_DATE'	, $result[0]['expire_date_time'] );

									$myMod->assign( 'LOGIN_ID'		, $result[0]['adm_login_id'] );
									$myMod->assign( 'ADM_NAME'		, $result[0]['adm_name'] );
									$myMod->assign( 'ADM_DESCRIBE'	, $result[0]['adm_describe'] );
									$myMod->assign( 'ADM_EMAIL'		, $result[0]['adm_email'] );


									// ---------------------------------------------------------------------- //
									// Check the login status
									// ---------------------------------------------------------------------- //
									if ( strtolower($result[0]['ac_enable']) == 'y' )
										$myMod->assign( 'login_allow'	, 'checked' );
									else
										$myMod->assign( 'login_deny'	, 'checked' );
									// ---------------------------------------------------------------------- //


									// ---------------------------------------------------------------------- //
									// Check the group and perpare to display
									// ---------------------------------------------------------------------- //
									$myGroup = new OESgroup();
									$myGroup->debug = 0;
									$myGroup->orderBy = 'group_name,id,group_enable';
									$myGroup->orderMode = 'ASC';
									$myGroup->selectLimit = 0;

									// Seperate the group id one by one
									if ( eregi( ',', substr( $result[0]['adm_group'], (strlen($result[0]['adm_group'])-1), strlen($result[0]['adm_group']) ) ) )
										$result[0]['adm_group'] = substr( $result[0]['adm_group'], 0, (strlen($result[0]['adm_group'])-1) );
									$adminGroupID = explode( ',', $result[0]['adm_group'] );


									// Get all group record
									$group = $myGroup->find();

									for ( $i=0, $j=0, $k=0; $i<count($group); $i++ )
									{
										// Assign the group name in the selection box
										if ( strtoupper($group[$i]['group_enable']) == 'Y' )
											$thisName = strtoupper($group[$i]['group_name']).' ('.$group[$i]['id'].')';
										else
											$thisName = strtoupper($group[$i]['group_name']).' ('.$myMod->getLangVAR('LANG=DISABLE').')';

										// Check if the administrator is the member of the group
										if ( in_array( strval($group[$i]['id']), $adminGroupID ) && $adminGroupID!='' )
										{
											// The administrator is in the group
											$myMod->assign( 'ADM_INGROUP', '<option value='.$group[$i]['id'].">$thisName</option>" );

											if ( ($j++ +1) < count($adminGroupID) )
												$myMod->repeatRow( 'ADM_INGROUP' );
										}
										else
										{
											// The administrator is in the group
											$myMod->assign( 'ADM_GROUP', '<option value='.$group[$i]['id'].">$thisName</option>" );

											if ( ($k++ +1) < (count($group)-count($adminGroupID)) || $result[0]['adm_group']=='' )
												$myMod->repeatRow( 'ADM_GROUP2' );
										}
									}
									// ---------------------------------------------------------------------- //


									// ---------------------------------------------------------------------- //
									// Display the Theme can be select
									// ---------------------------------------------------------------------- //
									// Try to open the admin theme directory
									if ( @$d = dir( $CONF_ADMIN_THEMES_PATH ) )
									{
										// read the sub directory of this theme
										$i=0;
										while (false !== ($entry = $d->read())) {
											if ( $entry != "." && $entry != ".." && is_dir($CONF_ADMIN_THEMES_PATH.'/'.$entry) ) 
												$themeList[$i++] = $entry;
										}
										$d->close();

										if ( count($themeList) )
										{
											// Sort the modules name
											sort( $themeList );

											$enableTheme = array();
											for ( $i=0, $j=0; $i<count($themeList); $i++ )
											{
												$themeConfigPath =  $CONF_ADMIN_THEMES_PATH.'/'.$themeList[$i].'/themes.php';
												if ( @include($themeConfigPath) )
												{
													// Check the themes is enable or disabled?
													if ( $THEMES_ENABLE )
													{
														$THEMES_NAME .= ':'.$themeList[$i];
														$enableTheme[$THEMES_NAME] = array();

														// Read the language set
														if ( $langDir = dir($CONF_ADMIN_THEMES_PATH.'/'.$themeList[$i].$THEMES_LANG_DIR) )
														{
															// Checking which language file in the theme
															$j=0;
															while (false !== ($langEntry = $langDir->read())) {
																// Only allow the file end with '*.lang.php' to be a language file
																if ( $langEntry != "." && $langEntry != ".." && eregi('^(.*)(.lang.php)$', $langEntry) ) 
																	$enableTheme[$THEMES_NAME][$j++] = $langEntry;
															}
															$langDir->close();

															// Check the language file on each themes
															for ($k=0; $k<count($enableTheme[$THEMES_NAME]); $k++)
															{
																if ( @include ($CONF_ADMIN_THEMES_PATH.'/'.$themeList[$i].$THEMES_LANG_DIR.'/'.$enableTheme[$THEMES_NAME][$k]) )
																{
																	// Perpare the JavaScript for dynamic change the selection
																	$lang = eregi_replace( '.lang.php', '', $enableTheme[$THEMES_NAME][$k] );
																	$enableTheme[$THEMES_NAME][$k] = 'new Array("'.$LANG_NAME.'", "'.$lang.'")';

																	// If the current theme is the same as the administrator selected,
																	// The display the current themes language set.
																	if ( $themeList[$i] == $result[0]['default_themes'] )
																	{
																		$myMod->assign( 'DEFAULT_LANG_NAME', $LANG_NAME );
																		$myMod->assign( 'LANG_VALUE', $lang );

																		// If the current language is same as the administrator selected, choose it
																		if ( $lang == $result[0]['default_lang'] )
																			$myMod->assign( 'langSelected', 'selected' );
																		else
																			$myMod->assign( 'langSelected', '' );

																		// If not finish to display the language, repeat a row
																		if ( ($k+1) < count($enableTheme[$THEMES_NAME]) )
																			$myMod->repeatRow( 'ADM_LANG' );
																	}
																}
															}
														}
													}
												}
											}

											// Generate the Javascript for dynamic change the selection
											$i=0;
											$langArray = '';
											foreach ( array_keys($enableTheme) as $themeName )
											{
												// Dynamic assign the themes to template 
												$name = explode ( ':', $themeName );
												$myMod->assign( 'DEFAULT_THEME', $name[0] );
												$myMod->assign( 'THEME_VALUE', $name[1] );												

												// The themes is current using, select it
												if ( $name[1] == $result[0]['default_themes'] )
													$myMod->assign( 'themeSelected', 'selected' );
												else
													$myMod->assign( 'themeSelected', '' );

												// Perpare JavaScript...
												if ( count($enableTheme[$themeName]) )
												{
													$langArray .= "Array ( ";
													$langArray .= 'new Array("-= '.$myMod->getLangVAR('LANG=DEFAULT').' ('.$name[0].') =-", ""),';
													for ( $count=0; $count<count($enableTheme[$themeName]); $count++)
													{
														$langArray .= $enableTheme[$themeName][$count];
														if ( ($count+1) < count($enableTheme[$themeName]) )
															$langArray .= ',';
													}
													$langArray .= " )";
												}
												else
													// This theme don't have any language file in, display the use as default.
													$langArray .= 'Array ( new Array("-= '.$myMod->getLangVAR('LANG=DEFAULT').' ('.$name[0].') =-", "") )';

												// If not finish display all the theme, repeat a ROW of template
												if ( ($i+++1) < count($enableTheme) )
												{
													$myMod->repeatRow( 'ADM_THEME' );
													$langArray .= ','."\n";
												}
											}
										}
									}

									// Assign the Javascript to the template
									$myMod->assign( 'LANG_ARRAY', $langArray );
									$myMod->assign( 'DEFAULT_LANG_NAME', '-= '.$myMod->getLangVAR('LANG=DEFAULT').' =-' );
									$myMod->assign( 'LANG_VALUE', '' );
									$myMod->assign( 'langSelected', '' );									
									// ---------------------------------------------------------------------- //


									// ---------------------------------------------------------------------- //
									// Check the IP access control
									// ---------------------------------------------------------------------- //
									if ( $result[0]['ip_access_list'] )
									{
										// If set the access list, ignore any from deny list
										$myMod->assign( 'IPchecked_allow', 'checked' );
										$myMod->assign( 'IP_ACCESS_LIST', eregi_replace( ",", "\n", $result[0]['ip_access_list'] ) );
									}
									elseif ( $result[0]['ip_deny_list'] )
									{
										// Only set the deny list
										$myMod->assign( 'IPchecked_deny', 'checked' );
										$myMod->assign( 'IP_ACCESS_LIST', eregi_replace( ",", "\n", $result[0]['ip_deny_list'] ) );
									}
									else
									{
										// Both IP access list are empty, that mean allow login from ALL domain
										$myMod->assign( 'IPchecked_any', 'checked' );
										$myMod->assign( 'IP_ACCESS_LIST', '' );
									}
									// ---------------------------------------------------------------------- //


									// ---------------------------------------------------------------------- //
									// Check the parent name (The account is created by this person)
									// ---------------------------------------------------------------------- //
									if ( $result[0]['parent'] >= 1 )
									{
										// Check the name in database
										$chkAdm = $adm->read($result[0]['parent']);
										$myMod->assign( 'PARENT', $chkAdm[0]['adm_name'].' (id='.$chkAdm[0]['id'].')' );
									}
									else
										$myMod->assign( 'PARENT', $myMod->getLangVAR('LANG=DEFAULT_CREATE_BY') );
									// ---------------------------------------------------------------------- //


									// ---------------------------------------------------------------------- //
									// Display the modules check box
									// ---------------------------------------------------------------------- //
									$modAllowList = '';
									if ( @$d = dir( $CONF_ADMIN_MODULES_PATH ) )
									{
										// read all modules for the administrator
										$i=0;
										while (false !== ($entry = $d->read())) {
											if ( $entry != "." && $entry != ".." && is_dir($CONF_ADMIN_MODULES_PATH.'/'.$entry) ) 
												$categoryList[$entry] = array();
										}
										$d->close();

										foreach ( array_keys($categoryList) as $category )
										{
											if ( @$modDir = dir( $CONF_ADMIN_MODULES_PATH.'/'.$category ) )
											{
												$i=0;
												while (false !== ($entry = $modDir->read())) {
													if ( $entry != "." && $entry != ".." && is_dir($CONF_ADMIN_MODULES_PATH.'/'.$category.'/'.$entry) ) 
														$categoryList[$category][$i++] = $entry;
												}
												$modDir->close();

												for ( $i=0; $i<count($categoryList[$category]); $i++ )
													if ( @include($CONF_ADMIN_MODULES_PATH.'/'.$category.'/'.$categoryList[$category][$i].'/module.php') )
														$categoryList[$category][$i] .= ':'.$MODULES["NAME"];
											}
											
										}
									}
									
									// Rearrange the order of categoty
									$sModules['0:oes']			= $categoryList['oes'];
									$sModules['1:user_account']	= $categoryList['user_account'];
									$sModules['2:system']		= $categoryList['system'];
									$sModules['3:modules']		= $categoryList['modules'];
									$sModules['4:support']		= $categoryList['support'];
									$categoryList = $sModules;

									// Split the modules setting in this account
									$modList = explode( '|', $result[0]['modules_allow'] );
									foreach ( $modList as $mod )
									{
										$mod = explode( ':', $mod );
										$modAllowed[$mod[0]] = explode( ',', $mod[1] );
									}

									$i=0;
									foreach ( array_keys($categoryList) as $category )
									{
										$categoryName = explode( ':', $category );
										$myMod->assign( 'CATEGORY', '-= '.strtoupper($categoryName[1]).' =-' );

										if ( !count($categoryList[$i.':'.$categoryName[1]]) )
										{
											$myMod->assign( 'CHECKBOX', '' );
											$myMod->assign( 'CHECKBOX_NAME', $myMod->getLangVAR('LANG=NONE_OF_MODULES') );
										}
										else
											for ( $j=0; $j<count($categoryList[$i.':'.$categoryName[1]]); $j++ )
											{
												$mod = explode( ':', $categoryList[$i.':'.$categoryName[1]][$j] );
												if ( is_array($modAllowed[$categoryName[1]]) && in_array( $mod[0], $modAllowed[$categoryName[1]] ) )
													$CHECKBOX = '<input type="checkbox" name="modAllow[]" value="'.$categoryName[1].'|'.$mod[0].'" checked>';
												else
													$CHECKBOX = '<input type="checkbox" name="modAllow[]" value="'.$categoryName[1].'|'.$mod[0].'">';
												$myMod->assign( 'CHECKBOX', $CHECKBOX );
												$myMod->assign( 'CHECKBOX_NAME', $mod[1] );

												if ( ($j+1) < count($categoryList[$i.':'.$categoryName[1]]) )
													$myMod->repeatRow( 'modules' );
											}
										
										if ( ($i+++1) < count($categoryList) )
										{
											// Delete the Repeat Row in the result part
											$myMod->removeRow( 'modules' );
											$myMod->repeatRow( 'category' );
										}
									}
									// ---------------------------------------------------------------------- //

									
									// display the final result in form of HTML
									echo $myMod->getResult();
									// ---------------------------------------------------------------------- //
								}

								break;
							}							


		case 'browse'	:	// List all the administrator account in the system
							$myMod = new myModTmp( $MODULES["TEMPLATE_LIST"], $SESS_CURRENT_LANG );
							$myMod->debug=0;
							$myMod->isAdmin=true;
							$myMod->getTemplate();

							// Perpare the request URL
							$requestURL = $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action='.$action;

							// -------------------------------------------------------------------------- //
							// Create the administrator account object to list all the admin account
							// -------------------------------------------------------------------------- //
							$listAdm = new Admin_Account();
							$listAdm->debug=0;

							// Checking the sorting mode is accending or descending
							$sortby = explode ( '|', $sortby );
							if ( strtoupper($sortby[1]) == 'DESC' )
							{
								$listAdm->orderMode = 'DESC';
								$sortmode = 'ASC';
							}
							else
							{
								$listAdm->orderMode = 'ASC';
								$sortmode = 'DESC';
							}
							$sortby = $sortby[0];


							// If set the display limit on eacg page
							if ( $listRecNum )
								$listAdm->selectLimit=( $listRecNum );
							else
								$listAdm->selectLimit=( 0 );

							// Calc. the page
							if ( $page )
								$listAdm->_selectOffset = ( $page * $listRecNum ) - $listRecNum;
							else
							{
								$page = 1;
								$listAdm->_selectOffset = 0;
							}


							// Dynamic assign the sory by URL
							$myMod->assign( 'SORT-BY_ID_URL'	, $requestURL.'&sortby=id|'.$sortmode.'&search='.$search );
							$myMod->assign( 'SORT-BY_STATUS_URL', $requestURL.'&sortby=status|'.$sortmode.'&search='.$search );
							$myMod->assign( 'SORT-BY_LOGIN_URL'	, $requestURL.'&sortby=login|'.$sortmode.'&search='.$search );
							$myMod->assign( 'SORT-BY_NAME_URL'	, $requestURL.'&sortby=name|'.$sortmode.'&search='.$search );

							// Consider sort the list by which field
							switch ( strtolower($sortby) )
							{
								case 'status'	: $sortByField = 'ac_enable'; $sortby='status'; break;
								case 'login'	: $sortByField = 'adm_login_id'; $sortby='login'; break;
								case 'name'		: $sortByField = 'adm_name'; $sortby='name'; break;
								case 'id'		: 
								default			: $sortByField = 'id'; $sortby='id'; break;
							}
							

							if ( isset($search) && $search!='' )
							{
								$listAdm->searchRegular = 'OR';

								// Search all simulator record
								$recResult = $listAdm->find($search,$search,$search,$search,
															$search,$search,$search,$search, 
															$sortByField);
							}
							else
								// Get the record
								$recResult = $listAdm->find('','','','','','','','', $sortByField);

							if ( ($page*$listRecNum-$listRecNum) >= $listAdm->recordNum )	
							{
								$myMod = new myModTmp( $MODULES["TEMPLATE_NO_REC"], $SESS_CURRENT_LANG );
								$myMod->debug=0;
								$myMod->isAdmin=true;
								$myMod->getTemplate();

								// Dynamic assignment the template variable
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL );

								// display the final result in form of HTML
								echo $myMod->getResult();
							}
							else
							{
								// Dsiplay the result in the table with dynamic field
								for ( $i=0; $i<count($recResult); $i++ )
								{
									$myMod->assign( 'ID'		, $recResult[$i]['id'] );
									if ( strtolower($recResult[$i]['ac_enable']) == 'y' )
										$myMod->assign( 'STATUS'	, 'LANG=ALLOW_LOGIN' );
									else
										$myMod->assign( 'STATUS'	, 'LANG=DENY_LOGIN' );
									$myMod->assign( 'LOGIN_ID'	, $recResult[$i]['adm_login_id'] );
									$myMod->assign( 'LOGIN_NAME', $recResult[$i]['adm_name'] );
									$myMod->assign( 'EDIT_URL'	, $PHP_SELF.'?category='.$category.'&mod='.implode('|',$modList).'&action=edit&id='.$recResult[$i]['id'] );

									if ( ($i+1) < count($listAdm->readArray) )
										$myMod->repeatRow( 'accountList' );
								}

								$totalPage = ceil($listAdm->recordNum/$listRecNum);
								$myMod->assign( 'CURR_REC'	, "$page" );
								$myMod->assign( 'TOTAL_REC'	, "$totalPage".' ('.$listAdm->recordNum.')' );

								// Generate the PREV button
								if ( $page > 1 )
								{
									$myMod->assign( 'PREV_URL_1'	, '<a href="'.$requestURL.'&sortby='.$sortby.'&page='.($page-1).'&search='.$search.'">' );
									$myMod->assign( 'PREV'			, $myMod->getLangVAR('LANG=PREV') );
									$myMod->assign( 'PREV_URL_2'	, '</a>' );
								}
								else
								{
									$myMod->assign( 'PREV_URL_1'	, '' );
									$myMod->assign( 'PREV'			, '' );
									$myMod->assign( 'PREV_URL_2'	, '' );
								}

								if ( (($page+1)*$listRecNum - $listRecNum) < $listAdm->recordNum )
								{
									$myMod->assign( 'NEXT_URL_1'	, '<a href="'.$requestURL.'&sortby='.$sortby.'&page='.($page+1).'&search='.$search.'">' );
									$myMod->assign( 'NEXT'			, $myMod->getLangVAR('LANG=NEXT') );
									$myMod->assign( 'NEXT_URL_2'	, '</a>' );
								}
								else
								{
									$myMod->assign( 'NEXT_URL_1'	, '' );
									if ( $page > 1 )
										$myMod->assign( 'NEXT'			, $myMod->getLangVAR('LANG=NEXT') );
									else
										$myMod->assign( 'NEXT'			, '' );
									$myMod->assign( 'NEXT_URL_2'	, '' );
								}


								// Dynamic assignment the template variable
								$myMod->assign( 'FORM_ACTION_PATH', $requestURL.'&search=' );

								if ( !$search )
								{
									$myMod->assign( 'SEARCH_VAL', '' );
									$myMod->assign( 'SEARCH_RESULT', 'LANG=LIST_ALL_RECORD' );
								}
								else
								{
									$myMod->assign( 'SEARCH_VAL', $search );
									$myMod->assign( 'SEARCH_RESULT', 'LANG=SEARCH RESULT' );
								}


								// display the final result in form of HTML
								echo $myMod->getResult();
							}

							// -------------------------------------------------------------------------- //
							

							break;


		default			:	// Create a modules template object
							$myMod = new myModTmp( $MODULES["TEMPLATE_MAIN"], $SESS_CURRENT_LANG );
							$myMod->debug=0;
							$myMod->isAdmin=true;
							$myMod->getTemplate();

							// Dynamic assignment the template variable
							$myMod->assign( 'MOD_URL_1', $URL_QUERY.'|'.$myMod->getLangVAR('LANG=ICON_NAME_1').'&action=create' );
							$myMod->assign( 'MOD_TEXT_1', 'LANG=ICON_NAME_1' );
							$myMod->assign( 'MOD_IMG_1A', $MODULES["ICON_CREATE_A"] );
							$myMod->assign( 'MOD_IMG_1B', 'IMG='.$MODULES["ICON_CREATE_B"] );

							$myMod->assign( 'MOD_URL_2', $URL_QUERY.'|'.$myMod->getLangVAR('LANG=ICON_NAME_2').'&action=browse' );
							$myMod->assign( 'MOD_TEXT_2', 'LANG=ICON_NAME_2' );
							$myMod->assign( 'MOD_IMG_2A', $MODULES["ICON_BROWSE_A"] );
							$myMod->assign( 'MOD_IMG_2B', 'IMG='.$MODULES["ICON_BROWSE_B"] );

							// display the final result in form of HTML
							echo $myMod->getResult();

	}

//phpinfo();
?>